<?php

namespace App\Repository;

use App\Entity\InternetOpen;
use Doctrine\Common\Collections\Criteria;
use Doctrine\DBAL\Driver\AbstractMySQLDriver;
use Doctrine\ORM\EntityRepository;
use Symfony\Component\Uid\Uuid;

/**
 * InternetOpenRepository.
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class InternetOpenRepository extends EntityRepository
{
    public function removeGroup($group)
    {
        $em = $this->getEntityManager();
        $query = $em->getRepository('App\Entity\InternetOpen')
            ->createQueryBuilder('i')
            ->delete()
            ->where('i.type = :type and i.account = :account')
            ->setParameter('type', 'group')
            ->setParameter('account', $group)
            ->getQuery();
        $results = $query->getResult();

        return $results;
    }

    public function removeUser($user)
    {
        $em = $this->getEntityManager();
        $query = $em->getRepository('App\Entity\InternetOpen')
            ->createQueryBuilder('i')
            ->delete()
            ->where('i.type = :type and i.account = :account')
            ->setParameter('type', 'user')
            ->setParameter('account', $user)
            ->getQuery();
        $results = $query->getResult();

        return $results;
    }

    public function getEndingTime($username)
    {
        $em = $this->getEntityManager();
//        $em->findBy()
    }

	public function getActiveIpLists() {
		return $this->matching(Criteria::create()
	                                ->where(Criteria::expr()->gt('close_at', new \DateTime('now')))
									->andWhere(Criteria::expr()->eq('type', 'ipList'))
								);
	}

	public function getActiveIpListIds() {
		return array_map(fn(InternetOpen $internetOpen) => $internetOpen->getAccount(), $this->getActiveIpLists()->toArray());
	}

	public function getActiveIpListIdsAsUuid() {
		if($this->getEntityManager()->getConnection()->getDriver() instanceof AbstractMySQLDriver) {
			return array_map(fn(InternetOpen $internetOpen) => (new Uuid($internetOpen->getAccount()))->toBinary(), $this->getActiveIpLists()->toArray());	//workaround to uuid implementation in mysql
		} else {
			return array_map(fn(InternetOpen $internetOpen) => (new Uuid($internetOpen->getAccount())), $this->getActiveIpLists()->toArray());
		}
	}
}
